;================================================
;	POCKET BALLOON G850
;	ver 1.00
;	for PC-G850 series
;	AASM 3.70
;	2007 08-10
;	by CHOI KYUN ikyun26@yahoo.co.jpj
;================================================



	include	"MACRO.ASM"		;{}N
	include "DEF.ASM"		;e`

	org	0100h



init:
	call	cls			;ʏ
	call	init_KEY		;L[
	call	init_LCDC		;LCDC
	call	init_BEEP		;BEEP

	call	print_CREDIT		;ҕ\
	call	title			;^Cg\

	call	randomize		;

	ld	hl,game_stat		;Q[̏
	ld	(hl),0

	call	init_hisc		;nCXRA


re_start:
	call	init_value		;eϐ
	call	init_status		;Xe[^Xʏ

	call	ready			;X^[g



main:
	{
		call	inkey		;L[
		call	animetion	;Aj

		call	clear_window	;ʃNA
		call	draw_bg		;BG`

		call	move_my_balloon	;o[ړ

		call	scroll_enemy	;QiGjXN[
		call	move_enemy	;QiGjړ

		call	scroll_item	;ACẽXN[
		call	set_new_item	;ACe쐬

		call	set_thunder	;
		call	move_thunder	;ړ

		call	disp_my_balloon	;o[\
		call	disp_enemy	;QiGj\
		call	disp_item	;ACe\
		call	disp_thunder	;\

		call	change_SE	;ʉ؂芷
		call	disp_screen	;XN[\
		call	check_over	;Q[I[o[
		call	game_over	;Q[I[o[
		call	pause		;|[Y

		ld	hl,game_speed	;Q[x
		inc	(hl)

		in	a,(01fh)	;[BREAK]L[ŏI
		rlca
		jr	nc,continue
	}



basic:
	call	cls
	call	info_VER_GAME		;o[W\
	call	info_VER_LIB
	ret



;------------------------------------------------
;	^Cg\
;------------------------------------------------
title:
	call	print_TITLE
	call	disp_screen
	call	print_SE
	{
		call	inkey
		call	change_Se
		call	disp_screen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	basic
		}
		ld	a,(keyf)
		bit	KEY_SPC,a
		jr	z,continue
	}
	call	clear_full_screen

	call	se_1
	ld	bc,800
	call	wait
	ret


	;^Cg\
print_TITLE:
	ld	d,1
	ld	hl,title_data
	{
		ld	e,23+SCREEN_BLANK
		ld	bc,96
		call	put_bitmap
		add	hl,bc
		inc	d
		ld	a,d
		cp	7
		jr	nz,continue
	}
	ret



;------------------------------------------------
;	ϐ
;------------------------------------------------
init_value:
	call	init_my_balloon	;@
	call	init_score	;XRA
	call	init_stage	;Xe[W
	call	init_item	;ACe

	xor	a
	ld	(game_stat),a	;Q[̐istO
	ld	(game_speed),a	;Q[xJE^
	ld	(anime_flg),a	;AjptO
	ld	(fire_flg),a	;\tO
	ld	(scroll_flg),a	;XN[tO
	ld	(thunder_flg),a	;tO

	ld	a,MAX_ENERGY
	ld	(energy),a	;GlM[

	ld	a,DEF_SCRL_TIME	;XN[JEg
	ld	(scroll_count),a

	ld	a,DEF_RANK	;NiQړxjl
	ld	(rank),a

	ld	a,DEF_BCD_RANK	;\pNJE^
	ld	(rank_bcd),a

	ld	a,DEF_RANK_UP_COUNT	;NAbvJEg
	ld	(rank_up_count),a

	ret



;------------------------------------------------
;	@
;------------------------------------------------
init_my_balloon:
	ld	hl,bal_x	;X^[gn_ 88,39
	ld	(hl),0		;bal_x
	inc	hl
	ld	(hl),88+SCREEN_BLANK
	inc	hl
	ld	(hl),0		;bal_y
	inc	hl
	ld	(hl),39+SCREEN_WIDTH
	inc	hl

	;XY
	ld	de,-NOMAL_JUMP_VX
	ld	(hl),e		;bal_vx
	inc	hl
	ld	(hl),d
	inc	hl
	ld	de,-NOMAL_JUMP_VY
	ld	(hl),e		;bal_vy
	inc	hl
	ld	(hl),d
	ret



;------------------------------------------------
;	Xe[W
;------------------------------------------------
init_stage:
	ld	hl,enemy_buf		;Gobt@NA
	ld	de,enemy_buf+1
	ld	bc,8*MAX_ENEMY-1
	ld	(hl),0
	ldir

	ld	b,MAX_ENEMY
	ld	hl,def_stage_data
	ld	de,enemy_buf+1
	{
		ld	a,(hl)		;X
		inc	hl
		ld	(de),a
		inc	de

		ld	a,(hl)		;Y
		inc	hl
		ld	(de),a

		ld	a,7
		ADD__DE_A		;macro  add de,a

		djnz	continue
	}
	ret



;------------------------------------------------
;	ACe
;------------------------------------------------
init_item:
	ld	b,MAX_ITEM
	ld	hl,def_item_data
	ld	de,item_buf
	{
		ld	a,(hl)		;X
		inc	hl
		ld	(de),a
		inc	de

		ld	a,(hl)		;Y
		inc	hl
		ld	(de),a
		inc	de

		djnz	continue
	}
	ld	a,MAX_ITEM
	ld	(item_num),a

	ld	a,NEXT_ITEM_COUNT
	ld	(new_item_count),a
	ret



;------------------------------------------------
;	Q[JnI
;------------------------------------------------
ready:
	call	draw_bg
	call	disp_my_balloon
	call	disp_start_point
	call	disp_enemy
	call	disp_item
	call	print_PUSH
	{
		call	inkey
		call	change_se
		call	disp_screen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	basic
		}
		ld	a,(keyf)
		bit	KEY_SPC,a
		jr	z,continue
	}
	call	se_1

	ld	bc,1000
	call	wait
	ret



	;on_`
disp_start_point:
	ld	de,48*256+88+SCREEN_BLANK	;88,48
	ld	hl,chr_START_POINT
	jp	put_chr


print_PUSH:
	ld	hl,mes_PUSH			;PUSH...
	ld	de,5*256+SCREEN_BLANK+14	;14,5
	ld	bc,68
	jp	put_bitmap



;------------------------------------------------
;	Q[I[o[
;------------------------------------------------
game_over:
	ld	a,(game_stat)
	bit	0,a
	ret	z

	call	over_animation	;Q[I[o[Aj[V
	call	fish_animation	;Ȃς

	ld	bc,1200
	call	wait

	call	se_3

	call	print_OVER
	call	print_RANK
	call	print_PUSH
	call	cmp_hisc			;nCXRAL^
	{
		call	inkey
		call	change_se
		call	disp_screen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SPC,a
		jr	z,continue
	}
	call	se_1

	ld	bc,1000
	call	wait

	xor	a
	ld	(game_stat),a

	call	clear_window
	pop	af
	jp	re_start



print_OVER:
	ld	hl,mes_OVER			;GAME OVER
	ld	de,2*256+SCREEN_BLANK+18	;18,2
	ld	bc,59
	jp	put_bitmap


print_RANK:
	ld	hl,mes_RANK			;RANK
	ld	de,3*256+SCREEN_BLANK+29	;29,3
	ld	bc,25
	call	put_bitmap
	jp	disp_rank_bcd


	;Q[I[o[̗
over_animation:
	{
		ld	a,(bal_y+1)
		cp	46+8
		ret	nc

		call	clear_window
		call	draw_bg
		call	disp_enemy
		call	disp_item
		call	disp_thunder

		call	_over_move_balloon
		call	disp_my_balloon
		call	disp_screen

		ld	hl,game_speed
		inc	(hl)
		jr	continue
	}


	;
fish_animation:
	ld	hl,bal_x+1
	ld	e,(hl)
	ld	d,6		;X,Y

	push	de
	ld	hl,chr_FISH
	ld	bc,8
	call	put_bitmap
	call	disp_screen

	ld	bc,300
	call	wait

	pop	de
	ld	hl,chr_FISH+8
	ld	bc,8
	call	put_bitmap
	call	disp_screen
	ret



;------------------------------------------------
;	|[Y
;------------------------------------------------
pause:
	ld	a,(keyf)
	bit	KEY_SHIFT,a
	ret	z

	call	se_2
	call	print_PAUSE
	{
		call	inkey
		call	change_se
		call	disp_screen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SHIFT,a
		jr	z,continue
	}
	call	se_2
	ret



print_PAUSE:
	ld	hl,mes_PAUSE			;PAUSE
	ld	de,6*256+SCREEN_BLANK		;0,6
	ld	bc,20
	jp	put_bitmap



;------------------------------------------------
;	o[ړ
;------------------------------------------------
move_my_balloon:
	call	key_operation		;L[

_over_move_balloon:
	ld	a,(game_speed)		;Q[x
	and	0000_0011b
	ret	nz

	ld	hl,(bal_x)		;X
	ld	de,(bal_vx)
	add	hl,de

	ld	a,h
	{
		cp	SCREEN_BLANK		;0 <= X <= 96
		jr	nc,break
		ld	hl,0
		ld	(bal_vx),hl
		ld	hl,SCREEN_BLANK*256+0
		jr	__y
	}
	{
		cp	WIN_WIDTH+SCREEN_BLANK-7
		jr	c,break
		ld	hl,0
		ld	(bal_vx),hl
		ld	hl,(WIN_WIDTH+SCREEN_BLANK-7)*256+0
	}
__y:
	ld	(bal_x),hl

	ld	hl,(bal_y)		;Y
	ld	de,(bal_vy)
	add	hl,de
	{
		ld	a,h
		cp	8		;Vɗ
		jr	nc,break
		ld	hl,NOMAL_JUMP_VY;˕Ԃ
		ld	(bal_vy),hl	
		ld	hl,0800h	;X = 8
	}
	ld	(bal_y),hl

	ld	hl,(bal_vy)		;d
	ld	de,NOMAL_G
	add	hl,de
	ld	(bal_vy),hl

	ret



	;L[
key_operation:
	ld	a,(keyf)

	bit	KEY_SPC,a		;Wv
	ret	z

	{
		ld	hl,energy		;GlM[
		dec	(hl)
		jr	nz,break
		ld	a,FLG_OVER
		ld	(game_stat),a
	}
	call	draw_gauge

	ld	hl,(bal_vy)		;Y
	ld	de,-NOMAL_JUMP_VY
	add	hl,de
	ld	(bal_vy),hl

	ld	hl,(bal_vx)		;X
	ld	de,-NOMAL_JUMP_VX
	add	hl,de
	ld	(bal_vx),hl

	call	se_1

	ld	a,DEF_FIRE_TIME		;\
	ld	(fire_flg),a

	ld	hl,(bal_vx)
	ld	a,(key)

_left:
	bit	KEY_4,a			;ړ
	jr	z,_right

	ld	de,-NOMAL_VX
	add	hl,de
	ld	(bal_vx),hl
	ret

_right:
	bit	KEY_6,a			;Eړ
	ret	z

	ld	de,NOMAL_VX
	add	hl,de
	ld	(bal_vx),hl
	ret



;------------------------------------------------
;	o[\
;------------------------------------------------
disp_my_balloon:
	ld	hl,chr_BALLOON

	ld	a,(bal_x+1)
	ld	e,a
	ld	a,(bal_y+1)
	ld	d,a

	call	put_chr

	;\
	ld	a,(fire_flg)
	or	a
	ret	z

	dec	a
	ld	(fire_flg),a

	ld	a,9
	add	a,d
	ld	d,a

	ld	hl,chr_FIRE
	jp	put_chr



;------------------------------------------------
;	Q̃XN[
;------------------------------------------------
scroll_enemy:
	ld	hl,scroll_count
	dec	(hl)
	ret	nz
	ld	(hl),DEF_SCRL_TIME

	ld	a,001h
	call	add_score		;XRAZ 10pts

	call	rank_up			;NAbv

	ld	a,1
	ld	(scroll_flg),a		;XN[tO
	ld	hl,new_item_count
	dec	(hl)			;VACe쐬JEg

	ld	b,MAX_ENEMY
	ld	hl,enemy_buf-7
	{
		ld	a,8
		ADD__HL_A		;macro add hl,a

		inc	(hl)		;X++
		djnz	continue
	}

	;폜`FbN
	ld	a,(hl)
	cp	WIN_WIDTH+SCREEN_BLANK-6
	ret	c

	call	set_new_enemy		;VQzu
	ret



;------------------------------------------------
;	Q㉺ړ
;------------------------------------------------
move_enemy:
	ld	b,MAX_ENEMY
	ld	de,8
	ld	ix,enemy_buf
	{
		{
			dec	(ix+4)
			jr	nz,break

			ld	a,(ix+3)
			ld	(ix+4),a	;Xs[hJE^

			ld	a,(ix+0)	;ړ -1 0 1
			ld	c,a
			add	(ix+2)		;㉺ړ
			{
				cp	8
				jr	nc,break
				ld	a,8
				ld	c,1	;]
			}
			{
				cp	50+1
				jr	c,break
				ld	a,50
				ld	c,-1	;]
			}
			ld	(ix+0),c
			ld	(ix+2),a
		}
		add	ix,de
		djnz	continue
	}
	call	check_hit_enemy			;QƂ̓蔻
	ret



;------------------------------------------------
;	QƂ̓蔻
;------------------------------------------------
check_hit_enemy:
	ld	b,MAX_ENEMY
	ld	ix,enemy_buf
	ld	de,8
	{
		ld	a,(ix+1)		;X2-x1 < W
		ld	hl,bal_x+1
		ld	c,(hl)
		inc	c
		inc	c			;X+2   XYS3dotŔ

		sub	c
		cp	BAL_X_SIZE+1
		jr	nc,_check_hit_enemy_next

		ld	a,(ix+2)		;Y2-Y1 < W
		ld	hl,bal_y+1
		ld	c,(hl)
		inc	c			;Y+1

		sub	c
		cp	BAL_Y_SIZE+1
		jr	nc,_check_hit_enemy_next

		ld	a,FLG_OVER		;Q[I[o[
		ld	(game_stat),a

		call	se_5
		ret


_check_hit_enemy_next:
		add	ix,de
		djnz	continue
	}
	ret



;------------------------------------------------
;	Q\
;------------------------------------------------
disp_enemy:
	ld	a,(anime_flg)
	ld	c,a

	ld	b,MAX_ENEMY
	ld	hl,enemy_buf+1
	{
		ld	e,(hl)		;X,Y
		inc	hl
		ld	d,(hl)

		ld	a,7
		ADD__HL_A		;macro  add hl,a

		push	hl
		ld	hl,chr_MINE
		{
			ld	a,c
			or	a
			jr	z,break
			ld	hl,chr_MINE+8
		}
		call	put_chr

		pop	hl
		djnz	continue
	}
	ret



;------------------------------------------------
;	VQ
;------------------------------------------------
set_new_enemy:
	ld	hl,enemy_buf+((MAX_ENEMY-1)*8-1)
	ld	de,enemy_buf+8+((MAX_ENEMY-1)*8-1)
	ld	bc,(MAX_ENEMY-1)*8
	lddr				;obt@擪󂯂

	ld	hl,enemy_buf
	call	rnd
	and	2
	dec	a

	ld	(hl),a			;ړ@-1 or 1
	inc	hl

	ld	(hl),2			;X=2
	inc	hl
	{
		call	rnd		;0..5
		and	7
		cp	6
		jr	nc,continue
	}
	add	a,a			;*8+12
	add	a,a
	add	a,a
	add	a,12
	ld	(hl),a			;Y=12...52 step 8
	inc	hl

	ld	a,(rank)		;N 8...24
	ld	b,a

	call	rnd
	and	7
	add	a,a
	add	a,a			;*4
	add	a,b
	ld	(hl),a			;Xs[h@RANK+0...RANK+28 step 4
	inc	hl

	ld	(hl),a
	ret



;------------------------------------------------
;	ACeXN[
;------------------------------------------------
scroll_item:
	ld	a,(item_num)
	or	a			;CP 0
	jr	z,_scroll_item_exit

	ld	b,a
	ld	c,a			;B=C=JEg

	ld	hl,item_buf
	dec	a
	add	a,a			;*2
	ld	e,a
	ld	d,0
	add	hl,de

	ld	e,l			;HL@obt@̃Gh|C^
	ld	d,h			;DE@obt@̃Jg|C^
	{
		{
			call	_scroll_item_sub
			jr	nc,break		;CY@폜tO

			;obt@폜
			dec	c			;JEg

			ld	a,(hl)
			ld	(de),a
			inc	hl
			inc	de
			ld	a,(hl)
			ld	(de),a			;(DE).w = (HL).w
			dec	hl
			dec	hl			;Gh|C^i߂
			dec	hl
			dec	de		;;;Ȃ񂩉R[h...
		}
		dec	de		;Jg|C^i߂
		dec	de		;DE-=2

		djnz	continue
	}
	ld	a,c
	ld	(item_num),a	;JEg


_scroll_item_exit:
	xor	a
	ld	(scroll_flg),a	;XN[tOZbg
	ret



	;XN[蔻
	;in:	DE	Jgobt@̃|C^
_scroll_item_sub:
	push_all
	ex	de,hl

	ld	a,(scroll_flg)
	or	a
	jr	z,_check_hit_item

	inc	(hl)		;X++
	{
		ld	a,(hl)
		cp	WIN_WIDTH+SCREEN_BLANK-5
		jr	c,break

		pop_all
		scf		;Cy = 1
		ret
	}


	;蔻
_check_hit_item:
	ld	de,bal_x+1	;XW
	ld	a,(de)		;MX-EX+a < a+b+1
	sub	(hl)
	add	a,BAL_X_SIZE+4
	cp	BAL_X_SIZE+ITEM_X_SIZE+4+1
	jr	nc,_check_hit_item_exit

	inc	hl
	ld	de,bal_y+1	;YW
	ld	a,(de)		;MY-EY+a < a+b+1
	sub	(hl)
	add	a,BAL_Y_SIZE+2
	cp	BAL_Y_SIZE+ITEM_Y_SIZE+2+1
	jr	nc,_check_hit_item_exit

	;I
	{
		ld	a,(energy)	;GlM[
		add	a,ENERGY_UP
		cp	MAX_ENERGY
		jr	c,break

		ld	a,MAX_ENERGY
	}
	ld	(energy),a
	call	draw_gauge		;Q[W`

	ld	a,020h
	call	add_score		;XRAZ 200pts
	call	se_2

	pop_all
	scf			;Cy = 1
	ret


_check_hit_item_exit:
	pop_all
	or	a		;Cy = 0
	ret



;------------------------------------------------
;	ACe\
;------------------------------------------------
disp_item:
	ld	a,(item_num)
	or	a
	ret	z

	ld	b,a
	ld	hl,item_buf
	{
		ld	e,(hl)		;X,Y
		inc	hl
		ld	d,(hl)
		inc	hl

		push	hl
		ld	hl,chr_ITEM
		call	put_chr

		pop	hl
		djnz	continue
	}
	ret


;------------------------------------------------
;	VACe̍쐬
;------------------------------------------------
set_new_item:
	ld	a,(new_item_count)
	or	a
	ret	nz

	ld	a,NEXT_ITEM_COUNT
	ld	(new_item_count),a

	call	rnd		;1/2
	and	1
	ret	z

	ld	a,(item_num)
	cp	MAX_ITEM
	ret	nc

	ld	hl,item_buf
	add	a,a		;*2
	ld	e,a
	ld	d,0
	add	hl,de

	ld	(hl),1		;X = 1
	inc	hl

	{
		call	rnd
		and	7
		cp	6
		jr	nc,continue	;Y = 0...5
	}
	inc	a
	add	a,a
	add	a,a
	add	a,a		;*8

	ld	(hl),a

	ld	hl,item_num
	inc	(hl)

	ret



;------------------------------------------------
;	ړ
;------------------------------------------------
move_thunder:
	ld	a,(thunder_flg)
	or	a
	ret	z

	ld	a,(game_speed)
	and	0000_0111b
	ret	nz

	ld	hl,thunder_x
	inc	(hl)
	ld	a,(hl)
	cp	WIN_WIDTH+SCREEN_WIDTH-4
	jr	nc,_move_thunder_exit

	inc	hl
	inc	(hl)
	ld	a,(hl)
	cp	30+SCREEN_WIDTH-6
	jr	nc,_move_thunder_exit

	call	check_hit_thunder	;蔻
	ret

_move_thunder_exit:
	xor	a
	ld	(thunder_flg),a		;
	ret



;------------------------------------------------
;	蔻
;------------------------------------------------
check_hit_thunder:
	ld	hl,thunder_x
	ld	a,(bal_x+1)
	add	a,2			;S3*3

	sub	(hl)
	add	BAL_X_SIZE
	cp	BAL_X_SIZE+THUNDER_X_SIZE+1
	ret	nc

	inc	hl
	ld	a,(bal_y+1)
	inc	a

	sub	(hl)
	add	BAL_Y_SIZE
	cp	BAL_Y_SIZE+THUNDER_Y_SIZE+1
	ret	nc

	ld	a,1
	ld	(game_stat),a		;Q[I[o[
	call	se_5
	ret



;------------------------------------------------
;	\
;------------------------------------------------
disp_thunder:
	ld	a,(thunder_flg)
	or	a
	ret	z

	ld	hl,thunder_x
	ld	e,(hl)
	inc	hl
	ld	d,(hl)

	ld	hl,chr_THUNDER
	jp	put_chr



;------------------------------------------------
;	V
;------------------------------------------------
set_thunder:
	ld	a,(thunder_flg)
	or	a
	ret	nz

	call	rnd
	and	15
	ret	nz

	call	rnd
	and	63		;X = 8...71
	add	a,SCREEN_WIDTH
	ld	(thunder_x),a

	xor	a
	ld	(thunder_y),a

	inc	a
	ld	(thunder_flg),a
	ret



;------------------------------------------------
;	BG`
;------------------------------------------------
draw_bg:
	ld	hl,chr_BG
	{
		ld	a,(anime_flg)	;Aj[V
		or	a
		jr	z,break
		ld	hl,chr_BG+8
	}

	ld	de,6*256+8
	ld	b,96/8
	{
		push	bc
		ld	bc,8
		call	put_bitmap

		ld	a,8
		add	a,e
		ld	e,a	;x+8

		pop	bc
		djnz	continue
	}
	ret



;------------------------------------------------
;	Aj[V
;------------------------------------------------
animetion:
	ld	a,(game_speed)
	and	0000_1111b
	ret	nz

	ld	a,(anime_flg)
	cpl

	ld	(anime_flg),a
	ret



;------------------------------------------------
;	NAbv
;------------------------------------------------
rank_up:
	ld	hl,rank_up_count
	dec	(hl)
	ret	nz

	ld	a,DEF_RANK_UP_COUNT
	ld	(hl),a
	{
		ld	a,(rank)
		cp	8+1
		jr	c,break

		dec	a
		ld	(rank),a

		ld	a,(rank_bcd)
		sub	1
		daa
		ld	(rank_bcd),a
	}
	ret



;------------------------------------------------
;	Q[I[o[
;------------------------------------------------
check_over:
	ld	a,(bal_y+1)
	cp	42+8
	ret	c

	ld	a,FLG_OVER
	ld	(game_stat),a
	ret



;------------------------------------------------
;	ʃNA
;------------------------------------------------
clear_window:
	ld	hl,screen_buf+SCREEN_WIDTH*6+SCREEN_BLANK+WIN_WIDTH
	jp	clear_screen



;------------------------------------------------
;	ʉ̐؂芷
;------------------------------------------------
change_se:
	ld	a,(keyf)
	bit	KEY_CLS,a
	ret	z

	ld	a,(sound)
	xor	1
	ld	(sound),a

	ld	b,a
	add	a,a
	add	a,b
	rrca
	rrca
	ld	(_beep+1),a		;00H or 0C0H
	call	print_SE
	jp	se_2



;------------------------------------------------
;	Xe[^Xʏ
;------------------------------------------------
init_status:
	call	print_line
	call	print_logo
	call	print_hi
	call	print_sc
	call	print_gauge
	call	print_se

	call	disp_hiscore
	call	disp_score
	ret


	;؂胉C
print_line:
	ld	hl,font_LINE
	ld	de,1*256+96+SCREEN_BLANK	;96,1
	ld	b,6
	{
		push	bc
		ld	bc,4
		call	put_bitmap

		add	hl,bc
		inc	d
		pop	bc
		djnz	continue
	}
	ret


	;^Cg
print_logo:
	ld	de,1*256+101+SCREEN_BLANK	;101,1
	ld	bc,44
	ld	hl,font_LOGO
	jp	put_bitmap


	;nCXRA
print_hi:
	ld	de,2*256+101+SCREEN_BLANK	;101,2
	ld	bc,27
	ld	hl,font_HI
	jp	put_bitmap


	;XRA
print_sc:
	ld	de,4*256+101+SCREEN_BLANK	;101,4
	ld	bc,29
	ld	hl,font_SC
	jp	put_bitmap


	;GlM[Q[W
print_gauge:
	ld	a,038h
	ld	hl,screen_buf+SCREEN_WIDTH*6+109
	ld	(hl),a
	ld	hl,screen_buf+SCREEN_WIDTH*6+142
	ld	(hl),a
	jr	draw_gauge


	;SEACR\
print_se:
	ld	a,(sound)
	add	a,a
	add	a,a
	add	a,a					;*8
	ld	e,a
	ld	d,0
	ld	hl,icon_SE
	add	hl,de

	ld	de,6*256+137+SCREEN_BLANK	;41,5
	ld	bc,SE_ICON_SIZE
	jp	put_bitmap



;------------------------------------------------
;	GlM[Q[W`
;------------------------------------------------
draw_gauge:
	ld	hl,screen_buf+SCREEN_WIDTH*6+110
	ld	b,32
	{
		ld	(hl),07ch	;
		inc	hl
		djnz	continue
	}
	dec	hl

	ld	a,(energy)
	ld	b,a
	ld	a,MAX_ENERGY
	sub	b

	srl	a			;/2
	ret	z

	ld	b,a
	{
		ld	(hl),044h	;
		dec	hl
		djnz	continue
	}
	ret



;------------------------------------------------
;	XRA
;------------------------------------------------
init_score:
	xor	a
	ld	hl,score		;XRA
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	(hl),a
	ret


init_hisc:
	xor	a
	ld	hl,hi_score		;nCXRA
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	(hl),a
	ret



;------------------------------------------------
;	XRAZ
;	in:	A	XRA
;------------------------------------------------
add_score:
	ld	hl,score+2

	add	a,(hl)
	daa
	ld	(hl),a
	dec	hl

	ld	a,0
	adc	a,(hl)
	daa
	ld	(hl),a
	dec	hl

	ld	a,0
	adc	a,(hl)
	daa
	ld	(hl),a

	call	disp_score		;XRA\
	ret



;------------------------------------------------
;	nCXRA̋L^
;------------------------------------------------
cmp_hisc:
	ld	hl,hi_score+2
	ld	a,(score+2)
	sub	(hl)
	daa

	dec	hl
	ld	a,(score+1)
	sbc	(hl)
	daa

	dec	hl
	ld	a,(score)
	sbc	(hl)
	daa

	ret	c

	ld	a,(score)
	ld	(hi_score),a
	ld	a,(score+1)
	ld	(hi_score+1),a
	ld	a,(score+2)
	ld	(hi_score+2),a
	ret



;------------------------------------------------
;	XRA\
;------------------------------------------------
disp_score:
	ld	hl,font_NUM				;0
	ld	de,5*256+139+SCREEN_BLANK		;139,5
	ld	bc,5
	call	put_bitmap

	ld	hl,score
	ld	de,5*256+109+SCREEN_BLANK		;109,5
	jp	put_BCD3				;6\



disp_hiscore:
	ld	hl,font_NUM				;0
	ld	de,3*256+139+SCREEN_BLANK		;139,3
	ld	bc,5
	call	put_bitmap

	ld	hl,hi_score
	ld	de,3*256+109+SCREEN_BLANK		;109,3
	jp	put_BCD3



disp_rank_bcd:
	ld	hl,rank_bcd
	ld	de,3*256+55+SCREEN_BLANK		;55,4
	jp	put_BCD


;------------------------------------------------
;	XN[\
;------------------------------------------------
disp_screen:
	ld	hl,screen_buf+SCREEN_WIDTH+SCREEN_BLANK
	jp	send_LCDC



;------------------------------------------------
;	ʉ
;------------------------------------------------
se_1:
	push_all
	ld	hl,440		;Wv
	ld	de,2
	call	beep

	ld	hl,580
	ld	de,2
	call	beep

	pop_all
	ret

se_2:
	push_all
	ld	hl,420		;ACe
	ld	de,8
	call	beep
	ld	hl,280
	ld	de,16
	call	beep

	pop_all
	ret

se_3:
	push_all
	ld	hl,800		;Q[I[o[
	ld	de,20
	call	beep

	ld	hl,1200
	ld	de,40
	call	beep
	pop_all
	ret

se_4:
	push_all
	ld	hl,440		;NA
	ld	de,20
	call	beep

	ld	hl,360
	ld	de,40
	call	beep
	pop_all
	ret

se_5:
	push_all
	ld	hl,900		;Dj
	ld	de,3
	call	beep

	ld	hl,1200
	ld	de,3
	call	beep
	pop_all
	ret



;------------------------------------------------
;	o[W\
;------------------------------------------------
info_VER_GAME:
	ld	hl,_g_ver
	ld	de,0			;X=0,Y=0
	ld	b,_g_end-_g_ver
	call	SYS_PUT_STRING
	ret


_g_ver:
	db	'POCKET BALLOON 1.00'
_g_end:



	include	"LIB.ASM"		;Cu
	include "DATA.ASM"		;f[^
	include	"WORK.ASM"		;[NGA



	end
	